//*********************************************************
//  PIC18F14K50 
//  File name: FreqCounter      Kazuo Iwamoto
//
//  Timer2ŃNbNiSMHjvXP1/4ɂāAPR2̒li249j
//  ZbgJԂƂPKHɂȂA|XgXPł1/10ŁA
//  100HɂȂB1001bɂȂB
//  Timer1ŊOpXvB16bit炠ӂꂽ̓\tg
//  T1CarryƂďώZB
//    LED       : PORTB RB4
//    pX: PORTC RC6
//
//    Notes   : 4MHzXtalNbN
//    Language: MPLAB C18
//    Target  : PIC18F14K50
// ----------------------------------------------------------------
// Timer1ApX̃JEgɎgpBD抄݂ɐݒ
// Timer2AԌvɎgpBD抄݂ɐݒ
// ----------------------------------------------------------------
#include <p18cxxx.h>
#include <timers.h>
#include "L_LCD.h"

#define LED LATBbits.LATB4

#pragma config FOSC = HS        //  Ttal 4MHzNbN
#pragma config USBDIV = OFF, CPUDIV = NOCLKDIV
#pragma config IESO  = OFF, FCMEN = OFF, PLLEN  = OFF
#pragma config BORV  = 30,  BOREN = OFF, PWRTEN = OFF
#pragma config WDTPS = 32768, WDTEN = OFF
#pragma config MCLRE = OFF, HFOFST = OFF, XINST  = OFF
#pragma config BBSIZ = OFF, LVP    = OFF, STVREN = ON
#pragma config CP1  = OFF, CP0  = OFF, CPD  = OFF, CPB  = OFF
#pragma config WRT1 = OFF, WRT0 = OFF, WRTB = OFF, WRTC = OFF
#pragma config EBTR1 = OFF, EBTR0 = OFF, EBTRB  = OFF

//------- vg^Cv ----------------
void ito_st(unsigned long, char *,char);
void isr_high(void);
void isr_low(void);

//------- eC^vgxNg --------
#pragma interrupt isr_high
#pragma interruptlow isr_low save = WREG,BSR,STATUS

#pragma code h_int_vect = 0x0008
void _h_isr (void){ _asm goto isr_high _endasm}

#pragma code l_int_vect = 0x0018
void _l_isr (void){ _asm goto isr_low _endasm}

#pragma code    
// -------------- ʕϐ ----------------------
unsigned int T1Carry = 0;        //
char T2Carry = 0;                //

//----------------------DC^vg------------------------
void isr_high(){
    if(PIR1bits.TMR2IF){            //Timer2̃C^vgmF
        PIR1bits.TMR2IF = 0;        // C^vgtbONA
        switch(T2Carry){
            case 0:
                T1CONbits.TMR1ON = 1;    // Timer1vJn
                T2Carry++;
                LED = 1;
                break;
            case 10:
                LED = 0;
                T2Carry++;
                break;
            case 100:
                Nop();
                Nop();
                Nop();
                Nop();
                T1CONbits.TMR1ON = 0;    // Timer1vI
                T2Carry++;
                break;
            case 101:
                break;
            default:
                T2Carry++;
                break;
        }
    }
}

//-----------------DC^vg̏------------------------
void isr_low(){
    if(PIR1bits.TMR1IF){            //Timer1̃C^vgmF
        PIR1bits.TMR1IF = 0;        // C^vgtbONA
            T1Carry++;              // Timer1̃JEgAbvώZ
    }
}    

//----------------------CvO-------------------------
void main(void){
    unsigned long T1Count;
    char MsgUpper[]= "12,456,890 Hz";
    LATC = 0;
    TRISC = 0b11000000;
    TRISB = 0;
    ANSEL = 0;
    ANSELH = 0;
//----------------------
    OpenTimer1(                // Timer 1 ݒ
        TIMER_INT_ON &
        T1_16BIT_RW &
        T1_SOURCE_EXT &
        T1_PS_1_1 &
        T1_OSC1EN_OFF &
        T1_SYNC_EXT_OFF    );
    IPR1bits.TMR1IP = 0;    // Timer 1 ̃C^vgDɐݒ
    PIR1bits.TMR1IF = 0;    // Timer 1 ̃C^vgtbONA

    OpenTimer2(             // Timer 2 ݒ
        TIMER_INT_ON &      // 10mSŊ݂
        T2_PS_1_4 &
        T2_POST_1_10 );
    PR2 = 249;              // Timer2 ̃JEg249ŃZbg
    IPR1bits.TMR2IP = 1;    // Timer2 ̃C^vgDɐݒ
    PIR1bits.TMR2IF = 0;    // Timer2 ̃C^vgtbONA

//----------------------
    T2Carry = 0;
    WriteTimer1(0);
    LCD_int();
    RCONbits.IPEN=1;        // QiK̃C^vgɐݒ
    INTCONbits.GIEH=1;      // DC^vg
    INTCONbits.GIEL=1;      // DC^vg

    while(1){
        if(T2Carry == 101){
            T1Count = T1Carry * 0x10000 + ReadTimer1();
            WriteTimer1(0);
            T1Carry = 0;
            T2Carry = 0;
            ito_st(T1Count, MsgUpper, 10);
            LCD_posyx(0,0);
            LCD_str(MsgUpper);
        }
	}
}
//****** 𕶎ɕϊ֐ ************************ 
//  num     ϊ鐮                  ([TvXj
//  strAdd  ϊʂ̊i[镶    (R}      j
//  digit   ϊ镶
//************************************************************
void ito_st(unsigned long num, char *strAdd, char digit){
    char i;    
    char flag=1;                        //[TvX Flag
    char coma=0;                        //R} Flag    
    strAdd += digit;                    // ̍Ō
    for(i=digit; i>0; i--) {            // ʌ珈
        strAdd--;                       // P
        if (flag == 1){        
            if (coma++ == 3){           //R} ̈ʒu    
                *strAdd = ',';          //R} i[    
                coma=0;
            }else{                      // P̐l𕶎Ŋi[
                *strAdd = (num % 10) + 0x30;
                num = num / 10;         // ̏
                if (num == 0) flag=0;   // [Ȃȍ~͗}
            }
        }else{                          // ʂ̂O͗}
            *strAdd = 0x20;             // ȎɃXy[Xi[
        }
    }
}
// --- Copyright (C) 2011-2012 Kazuo Iwamoto All Rights Reserved. ---
